<form (ngSubmit)="onSubmit()"
      [formGroup]="form"
>

  <solidify-detail-presentation [centerTemplate]="centerTemplate"
                                [leftTemplate]="leftTemplate"
                                [rightTemplate]="rightTemplate"
  ></solidify-detail-presentation>

  <ng-template #leftTemplate>
    <solidify-avatar-upload-wrapper-container [resId]="personResId"
                                              [resourceFileNameSpace]="personAvatarActionNameSpace"
                                              [resourceFileState]="$any(personState)"
                                              [userInfo]="getUser()"
                                              [isAvatarMissing]="isAvatarPresent | isFalse"
                                              [uploadInstantly]="false"
                                              [isEditable]="(model | isNullOrUndefined) || editAvailable"
                                              (logoChange)="logoChange($event)"
                                              class="avatar"
    ></solidify-avatar-upload-wrapper-container>
  </ng-template>

  <ng-template #centerTemplate>

    <mat-form-field *ngIf="getFormControl(formDefinition.firstName) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.firstName | translate }}</mat-label>
      <input [formControl]="fd"
             [required]="formValidationHelper.hasRequiredField(fd)"
             [solidifyFocusFirstElement]="true"
             matInput
             solidifyValidation
      >
      <mat-error solidifyTooltipOnEllipsis
                 #errors
      ></mat-error>
    </mat-form-field>

    <mat-form-field *ngIf="getFormControl(formDefinition.lastName) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.lastName | translate }}</mat-label>
      <input [formControl]="fd"
             [required]="formValidationHelper.hasRequiredField(fd)"
             matInput
             solidifyValidation
      >
      <mat-error solidifyTooltipOnEllipsis
                 #errors
      ></mat-error>
    </mat-form-field>

    <mat-form-field *ngIf="getFormControl(formDefinition.orcid) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.orcid | translate }}</mat-label>
      <input (blur)="checkAvailable(formDefinition.orcid, fd)"
             [formControl]="fd"
             [required]="formValidationHelper.hasRequiredField(fd)"
             matInput
             solidifyValidation
      >
      <solidify-button-orcid [orcid]="fd?.value"
                             [isVerifiedOrcid]="(model?.verifiedOrcid | isTrue)"
                             [isButton]="true"
                             [isPristineForm]="fd.pristine"
                             class="orcid-button"
                             matSuffix
      ></solidify-button-orcid>
      <mat-error solidifyTooltipOnEllipsis
                 #errors
      ></mat-error>
    </mat-form-field>

    <dlcm-shared-table-orgunit-role-container [formControl]="getFormControl(formDefinition.orgUnitRole)"
                                              [listRole]="listRole"
                                              [readonly]="readonly"
                                              [selectedResourceRole]="selectedOrgUnitRole"
                                              (navigate)="navigate($event)"
    ></dlcm-shared-table-orgunit-role-container>

    <dlcm-shared-table-institution-role-container [formControl]="getFormControl(formDefinition.institutionRole)"
                                                  [listRole]="listRole"
                                                  [readonly]="readonly"
                                                  [selectedResourceRole]="selectedInstitutionRole"
                                                  (navigate)="navigate($event)"
    ></dlcm-shared-table-institution-role-container>

  </ng-template>

  <ng-template #rightTemplate>

    <solidify-searchable-multi-select (navigate)="navigateToInstitution($event)"
                                      *ngIf="getFormControl(formDefinition.institutions) as fd"
                                      [formControl]="fd"
                                      [isWithLink]="true"
                                      [labelKey]="'name'"
                                      [placeholder]="labelTranslateEnum.clickHereToAddAnInstitution | translate"
                                      [required]="formValidationHelper.hasRequiredField(fd)"
                                      [resourceNameSpace]="sharedInstitutionActionNameSpace"
                                      [sort]="sharedInstitutionSort"
                                      [state]="sharedInstitutionState"
                                      [title]="labelTranslateEnum.institutions | translate"
                                      [tooltipNavigateToTranslate]="labelTranslateEnum.seeInstitutionDetail | translate"
                                      [valueKey]="'resId'"
                                      [overlayComponent]="$any(institutionOverlayComponent)"
                                      aria-label="institution"
                                      solidifyValidation
    >
    </solidify-searchable-multi-select>

    <button (click)="navigateToContributor()"
            *ngIf="model | isNotNullNorUndefined"
            solidifyAlternativeButton
    >
      {{labelTranslateEnum.seeContributorDetail | translate}}
    </button>

  </ng-template>

  <dlcm-shared-additional-information-panel-container *ngIf="model | isNotNullNorUndefined"
                                                      [resource]="model"
  >
  </dlcm-shared-additional-information-panel-container>
</form>
